// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Fixtures.Azure.AcceptanceTestsLro.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Defines headers for post202RetryInvalidHeader operation.
    /// </summary>
    public partial class LROSADsPost202RetryInvalidHeaderHeaders
    {
        /// <summary>
        /// Initializes a new instance of the
        /// LROSADsPost202RetryInvalidHeaderHeaders class.
        /// </summary>
        public LROSADsPost202RetryInvalidHeaderHeaders() { }

        /// <summary>
        /// Initializes a new instance of the
        /// LROSADsPost202RetryInvalidHeaderHeaders class.
        /// </summary>
        /// <param name="location">Location to poll for result status: will be
        /// set to /foo</param>
        /// <param name="retryAfter">Number of milliseconds until the next
        /// poll should be sent, will be set to /bar</param>
        public LROSADsPost202RetryInvalidHeaderHeaders(string location = default(string), int? retryAfter = default(int?))
        {
            Location = location;
            RetryAfter = retryAfter;
        }

        /// <summary>
        /// Gets or sets location to poll for result status: will be set to
        /// /foo
        /// </summary>
        [JsonProperty(PropertyName = "Location")]
        public string Location { get; set; }

        /// <summary>
        /// Gets or sets number of milliseconds until the next poll should be
        /// sent, will be set to /bar
        /// </summary>
        [JsonProperty(PropertyName = "Retry-After")]
        public int? RetryAfter { get; set; }

    }
}
